/**
 * @file Spinner
 * @description
 * @author fex
 * @date 2017-11-07
 */
/// <reference types="hoist-non-react-statics" />
import React from 'react';
import { ClassNamesFn } from '../theme';
interface SpinnerProps {
    overlay: boolean;
    spinnerClassName: string;
    mode: string;
    size: 'sm' | 'lg' | '';
    classPrefix: string;
    classnames: ClassNamesFn;
    show: boolean;
}
export declare class Spinner extends React.Component<SpinnerProps, object> {
    static defaultProps: Pick<SpinnerProps, 'overlay' | 'spinnerClassName' | 'size' | 'mode' | 'show'>;
    div: React.RefObject<HTMLDivElement>;
    overlay: React.RefObject<HTMLDivElement>;
    render(): JSX.Element;
}
declare const _default: {
    new (props: Readonly<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, "mode" | "show" | "overlay" | "size" | "spinnerClassName">> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never>> & {
        theme?: string | undefined;
        classPrefix?: string | undefined;
        classnames?: ClassNamesFn | undefined;
    }>): {
        render(): JSX.Element;
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, "mode" | "show" | "overlay" | "size" | "spinnerClassName">> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never>> & {
            theme?: string | undefined;
            classPrefix?: string | undefined;
            classnames?: ClassNamesFn | undefined;
        }>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, "mode" | "show" | "overlay" | "size" | "spinnerClassName">> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never>> & {
            theme?: string | undefined;
            classPrefix?: string | undefined;
            classnames?: ClassNamesFn | undefined;
        }> & Readonly<{
            children?: React.ReactNode;
        }>;
        state: Readonly<{}>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, "mode" | "show" | "overlay" | "size" | "spinnerClassName">> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never>> & {
            theme?: string | undefined;
            classPrefix?: string | undefined;
            classnames?: ClassNamesFn | undefined;
        }>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, "mode" | "show" | "overlay" | "size" | "spinnerClassName">> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never>> & {
            theme?: string | undefined;
            classPrefix?: string | undefined;
            classnames?: ClassNamesFn | undefined;
        }>, prevState: Readonly<{}>): any;
        componentDidUpdate?(prevProps: Readonly<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, "mode" | "show" | "overlay" | "size" | "spinnerClassName">> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never>> & {
            theme?: string | undefined;
            classPrefix?: string | undefined;
            classnames?: ClassNamesFn | undefined;
        }>, prevState: Readonly<{}>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, "mode" | "show" | "overlay" | "size" | "spinnerClassName">> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never>> & {
            theme?: string | undefined;
            classPrefix?: string | undefined;
            classnames?: ClassNamesFn | undefined;
        }>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, "mode" | "show" | "overlay" | "size" | "spinnerClassName">> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never>> & {
            theme?: string | undefined;
            classPrefix?: string | undefined;
            classnames?: ClassNamesFn | undefined;
        }>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, "mode" | "show" | "overlay" | "size" | "spinnerClassName">> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never>> & {
            theme?: string | undefined;
            classPrefix?: string | undefined;
            classnames?: ClassNamesFn | undefined;
        }>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, "mode" | "show" | "overlay" | "size" | "spinnerClassName">> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never>> & {
            theme?: string | undefined;
            classPrefix?: string | undefined;
            classnames?: ClassNamesFn | undefined;
        }>, nextState: Readonly<{}>, nextContext: any): void;
    };
    new (props: Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, "mode" | "show" | "overlay" | "size" | "spinnerClassName">> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never>> & {
        theme?: string | undefined;
        classPrefix?: string | undefined;
        classnames?: ClassNamesFn | undefined;
    }, context?: any): {
        render(): JSX.Element;
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, "mode" | "show" | "overlay" | "size" | "spinnerClassName">> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never>> & {
            theme?: string | undefined;
            classPrefix?: string | undefined;
            classnames?: ClassNamesFn | undefined;
        }>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, "mode" | "show" | "overlay" | "size" | "spinnerClassName">> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never>> & {
            theme?: string | undefined;
            classPrefix?: string | undefined;
            classnames?: ClassNamesFn | undefined;
        }> & Readonly<{
            children?: React.ReactNode;
        }>;
        state: Readonly<{}>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, "mode" | "show" | "overlay" | "size" | "spinnerClassName">> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never>> & {
            theme?: string | undefined;
            classPrefix?: string | undefined;
            classnames?: ClassNamesFn | undefined;
        }>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, "mode" | "show" | "overlay" | "size" | "spinnerClassName">> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never>> & {
            theme?: string | undefined;
            classPrefix?: string | undefined;
            classnames?: ClassNamesFn | undefined;
        }>, prevState: Readonly<{}>): any;
        componentDidUpdate?(prevProps: Readonly<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, "mode" | "show" | "overlay" | "size" | "spinnerClassName">> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never>> & {
            theme?: string | undefined;
            classPrefix?: string | undefined;
            classnames?: ClassNamesFn | undefined;
        }>, prevState: Readonly<{}>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, "mode" | "show" | "overlay" | "size" | "spinnerClassName">> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never>> & {
            theme?: string | undefined;
            classPrefix?: string | undefined;
            classnames?: ClassNamesFn | undefined;
        }>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, "mode" | "show" | "overlay" | "size" | "spinnerClassName">> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never>> & {
            theme?: string | undefined;
            classPrefix?: string | undefined;
            classnames?: ClassNamesFn | undefined;
        }>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, "mode" | "show" | "overlay" | "size" | "spinnerClassName">> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never>> & {
            theme?: string | undefined;
            classPrefix?: string | undefined;
            classnames?: ClassNamesFn | undefined;
        }>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, "mode" | "show" | "overlay" | "size" | "spinnerClassName">> & Partial<Pick<Pick<SpinnerProps, "mode" | "show" | "overlay" | "size" | "spinnerClassName">, never>> & {
            theme?: string | undefined;
            classPrefix?: string | undefined;
            classnames?: ClassNamesFn | undefined;
        }>, nextState: Readonly<{}>, nextContext: any): void;
    };
    displayName: string;
    contextType: React.Context<string>;
    ComposedComponent: typeof Spinner;
} & import("hoist-non-react-statics").NonReactStatics<typeof Spinner, {}> & {
    ComposedComponent: typeof Spinner;
};
export default _default;
